


REVISION  -crc "--- 0.5O crc : Compute the crc of an area ---"

\ Wrapper around crcword, using three parameters from data stack
CODE OneCrc
    >r0,
    dpop, ( crcgen)
    dpop, ( oldcrc)
    dpop, ( word)
    crcword,
    dpush,
    r0>,
    gcall,
END-CODE

\ The generating polynomial.
$EDB88320 CONSTANT CrcGen

\ Return the crc CRC of the range [LOW,HIGH) [inclusive, not inclusive)
\ using above generator.
\ A descheduling point is introduced at the end of the loop, otherwise
\ this cannot be called from a background process.
: CrcOfArea     ( address LOW, address HIGH -- int CRC )
    LOCAL END
    LOCAL Pointer     \ Walks through codespace
    0 LOCAL Crc                 \ Current value of the checksum

   BEGIN               \ Compute crc
       Pointer @ Crc CrcGen  OneCrc   TO Crc
       1 CELLS +TO Pointer
       Pointer END < WHILE
   REPEAT       \ Force a descheduling point
   Crc
;
