\ COPYRIGHT 1992@1998 DUTCH FORTH WORKSHOP - FILENAME : TWINMISC.FRT #1

REVISION -twinmisc " 0.5V --- twinerr : log errors ---"

\ Contains pairs of machine and error each.
CREATE ERRORS 1000 CELLS ALLOT
ERRORS VALUE CURRENT-ERROR

\ Store I into the error log.
: TO-ERROR-LOG          ( int I -- )
    CURRENT-ERROR !    1 CELLS +TO CURRENT-ERROR
;

\ This is serious: an antibugging error number IERR
\ See table in error.txt
\ With extra information in INFO , that depends on the error.
: TWIN-ERROR    ( int IERR, int INFO -- )
    TO-ERROR-LOG TO-ERROR-LOG
;

\ Scale the double number D by 1G, obtaining a single precision number I
: 1G-SCALE ( double D -- int I )
    1000000000 FM/MOD SWAP DROP
;
